package bokoworker

/*
	Boko Worker

	A boko worker is an instance of WebDAV file server that serves a specific
	disk partition or subpath in which the user can interact with the disk
	via WebDAV interface
*/

type Worker struct {
	/* Worker Properties */
	UUID     string //UUID of this worker
	RootPath string //The root path request by this worker, e.g. /disk1
	DiskUUID string // Disk UUID, when provided, will be used instead of disk path
	DiskPath string // Disk device path (e.g. /dev/sda1), Disk UUID will have higher priority
	Subpath  string // Subpath to serve, default is root
	ReadOnly bool   //Label this worker as read only

}
